// Guided Inquiry 26.1
//
// Instructions
// ------------
// The program below should prompt the user for the name of a file to save
// to and a message to write to the file. It should then write that message to
// the file.
//
// Complete `Run()` so that it performs those operations.
//
// Testing
// -------
// To test your code, compile as usual, but when you run, do this:
//
//     ./gi26.1 -test
// 
//
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <cstdlib>
#include <ctime>
using namespace std;

// For testing; do not modify.
void RunTests();
bool RandomFileTest(int testNum);
bool NonExistentDirectoryTest(int testNum);
// End testing declarations.


void Run(){
    // TODO Your code goes here.

    // create output file stream instance; call it fout
    // declare strings to hold the filename and user message
    // prompt the user for the name of the file to write to: "Filename: " (no 
    //      new line)
    // use getline to read in the filename
    // prompt the user for a message: "Message: " (no new line)
    // use getline to read in the message
    // open file for writing
    // if it didn't open:
    //    print an error message: "Error: file couldn't be opened." with newline
    //          at the end
    //    return
    // write the message
    // close the file -- this is hugely important when writing to a file (not
    //                   closing could cause some data to not be written to the
    //                   file)
}

int main(int argc, char **argv) {
    // For testing. Don't modify this code.
    if(argc > 1 && string(argv[1]) == "-test"){
        RunTests();
    } else {
        Run();
    }
    // End testing.

    return 0;
}





// ============================================================================
// IGNORE the testing function definitions below here. 
// ---------------------------------------------------
void RunTests(){
    const int TESTS = 5;
    srand(time(0));
    int testsPassed = 0;

    cout << string(80, '=') << endl
         << "TESTS" << endl
         << string(40, '-') << endl;
    for(int i = 0; i < TESTS-1; i++){
        if(RandomFileTest(i+1))
            testsPassed++;
        cout << string(40, '-') << endl;
    }
    if(NonExistentDirectoryTest(TESTS))
        testsPassed++;
    cout << string(40, '-') << endl;

    cout << endl << "*** " << testsPassed << " of " << TESTS 
         << " tests passed. ***" << endl << endl;
}

bool RandomFileTest(int testNum){
    ostringstream message("");
    message << "hello, I'm "<< rand()%1000 << " years old.";
    ostringstream filename("");
    filename << "test_" << testNum << "_" << rand()%1000;
    ostringstream inputStream("");
    inputStream << filename.str() << endl
                << message.str() << endl;


    ifstream fin;
    string expectedStdout, actualStdout, expectedFileContent = message.str(), 
           actualFileContent;
    ostringstream stdoutMirror, expectedStream("");
    istringstream stdInMirror(inputStream.str());
    streambuf *origStdout, *origStdin;
    


    origStdout = cout.rdbuf();
    cout.rdbuf(stdoutMirror.rdbuf());
    origStdin = cin.rdbuf();
    cin.rdbuf(stdInMirror.rdbuf());

    Run();

    expectedStdout = "Filename: Message: ";
    actualStdout = stdoutMirror.str();

    cout.rdbuf(origStdout);
    cin.rdbuf(origStdin);

    fin.open(filename.str().c_str());

    if(fin.is_open()){

        getline(fin, actualFileContent);
        fin.close();
        remove(filename.str().c_str());

        if(expectedStdout == actualStdout && expectedFileContent == actualFileContent){
            cout << "Test " << testNum << " passed! Your output matches the "
                << "expected output. Console output:" <<endl
                << ">>>>>>" << endl
                << expectedStdout << endl
                << "<<<<<<" << endl << endl;
            cout << "File contents:" << endl
                << ">>>>>" << endl 
                << expectedFileContent << endl 
                << "<<<<<" << endl << endl;
            return true;
        } else {
            cout << "Test " << testNum << " failed. Expected console output:" << endl
                << ">>>>>>" << endl
                << expectedStdout << endl
                << "<<<<<<" << endl
                << "The actual console output:" << endl
                << ">>>>>>" << endl
                << actualStdout << endl
                << "<<<<<<" << endl << endl;
            cout << "Expected file contents: " << endl
                << ">>>>>>" << endl
                << expectedFileContent << endl
                << "<<<<<<" << endl
                << "The actual file contents:" << endl
                << ">>>>>>" << endl
                << actualFileContent << endl
                << "<<<<<<" << endl << endl;
            return false;
        }
    } else {
        cout << "Test " << testNum << " failed. The output file was not "
             << "produced." << endl << endl;
        return false;
    }
}

bool NonExistentDirectoryTest(int testNum){
    ostringstream message("");
    message << "hello, I'm "<< rand()%1000 << " years old.";
    ostringstream filename("");
    filename << "test_" << testNum << "_" << rand()%1000 
             << "/test_" << testNum << "_" << rand()%1000;
    ostringstream inputStream("");
    inputStream << filename.str() << endl
                << message.str() << endl;

    string expected, actual;
    ostringstream stdoutMirror, expectedStream("");
    istringstream stdInMirror(inputStream.str());
    streambuf *origStdout, *origStdin;
    origStdout = cout.rdbuf();
    cout.rdbuf(stdoutMirror.rdbuf());
    origStdin = cin.rdbuf();
    cin.rdbuf(stdInMirror.rdbuf());

    Run();

    expectedStream << "Filename: Message: Error: file couldn't be opened.\n";
    expected = expectedStream.str();
    actual = stdoutMirror.str();

    //remove(filename.c_str());
    cout.rdbuf(origStdout);
    cin.rdbuf(origStdin);


    if(expected == actual){
        cout << "Test " << testNum << " passed! Your output matches the "
             << "expected output." <<endl
             << ">>>>>>" << endl
             << expected << endl
             << "<<<<<<" << endl << endl;
        return true;
    } else {
        cout << "Test " << testNum << " failed. Expected output:" << endl
             << ">>>>>>" << endl
             << expected << endl
             << "<<<<<<" << endl
             << "The actual output:" << endl
             << ">>>>>>" << endl
             << actual << endl
             << "<<<<<<" << endl;
        return false;
    }
}
