// Guided Inquiry 26.2
//
// Instructions
// ------------
// The program below should:
//  1. Prompt the user for a contact's information and read each of those into 
//     an instance of the Contact struct; The six prompts should look like this:
//      "Name: "
//      "Email: "
//      "Phone number: "
//      "Birth Year: "
//      "Birth Month: "
//      "Birth Day: "
//
//  2. Prompt the user for the name of a file
//  3. Write the struct fields to the file in the format (no leading spaces):
//      name
//      email
//      phoneNumber
//      birthYear birthMonth birthDay
//    There should be a newline at the end.
//
// Complete `Run()` so that it performs those operations.
//
// Testing
// -------
// To test your code, compile as usual, but when you run, do this:
//
//     ./gi26.2 -test
//
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <cstdlib>
#include <ctime>
using namespace std;

// For testing; do not modify.
void RunTests();
bool RandomFileTest(int testNum);
bool NonExistentDirectoryTest(int testNum);
// End testing declarations.

struct Contact {
    string name, email, phoneNumber;
    int birthYear, birthMonth, birthDay;
};

void Run(){
    // TODO Your code goes here.

    // create output file stream instance; call it fout
    // declare a string to hold the filename
    // declare an instance of Contact
    // prompt the user for each data member of the struct as formatted in the
    //   instructions and read them in; be sure to use getline for strings and
    //   mind the newline left after using `cin >> ...` for ints.
    // prompt the user for the name of the file to write to: "Filename: " (no 
    //      new line)
    // use getline to read in the filename
    // open file for writing
    // if it didn't open:
    //    print an error message: "Error: file couldn't be opened." with newline
    //          at the end
    //    return
    // write the struct data members out as detailed in the instructions
    // close the file -- this is hugely important when writing to a file (not
    //                   closing could cause some data to not be written to the
    //                   file)
}

int main(int argc, char **argv) {
    // For testing. Don't modify this code.
    if(argc > 1 && string(argv[1]) == "-test"){
        RunTests();
    } else {
        Run();
    }
    // End testing.

    return 0;
}





// ============================================================================
// IGNORE the testing function definitions below here. 
// ---------------------------------------------------
void RunTests(){
    const int TESTS = 5;
    srand(time(0));
    int testsPassed = 0;

    cout << string(80, '=') << endl
         << "TESTS" << endl
         << string(40, '-') << endl;
    for(int i = 0; i < TESTS-1; i++){
        if(RandomFileTest(i+1))
            testsPassed++;
        cout << string(40, '-') << endl;
    }
    if(NonExistentDirectoryTest(TESTS))
        testsPassed++;
    cout << string(40, '-') << endl;

    cout << endl << "*** " << testsPassed << " of " << TESTS 
         << " tests passed. ***" << endl << endl;
}

bool RandomFileTest(int testNum){
    ostringstream tmp("");

    Contact contact;
    tmp << "Jane Doe " << testNum;
    contact.name = tmp.str();
    tmp.str("");
    tmp << "jdoe" << testNum << "@mail.com";
    contact.email = tmp.str();
    tmp.str("");
    for(int i = 0; i < 12; i++){
        if(i == 4 || i == 8){
            tmp << "-";
        } else {
            tmp << rand()%10;
        }
    }
    contact.phoneNumber= tmp.str();
    contact.birthYear = rand()%80 + 1960;
    contact.birthMonth = rand()%12 + 1;
    contact.birthDay = rand()%27+1;

    ostringstream filename("");
    filename << "test_" << testNum << "_" << rand()%1000;
    ostringstream inputStream("");
    inputStream << contact.name << endl
                << contact.email << endl
                << contact.phoneNumber << endl
                << contact.birthYear << endl
                << contact.birthMonth << endl
                << contact.birthDay << endl
                << filename.str() << endl;

    tmp.str("");
    tmp << contact.name << endl
        << contact.email << endl
        << contact.phoneNumber << endl
        << contact.birthYear << " "
        << contact.birthMonth << " "
        << contact.birthDay << endl;

    ifstream fin;
    string expectedStdout, actualStdout, expectedFileContent = tmp.str(), 
           actualFileContent;
    ostringstream stdoutMirror, expectedStream(""), actualFilecontentStream("");
    istringstream stdInMirror(inputStream.str());
    streambuf *origStdout, *origStdin;
    


    origStdout = cout.rdbuf();
    cout.rdbuf(stdoutMirror.rdbuf());
    origStdin = cin.rdbuf();
    cin.rdbuf(stdInMirror.rdbuf());

    Run();

    expectedStdout = "Name: Email: Phone number: Birth year: Birth month: Birth day: Filename: ";
    actualStdout = stdoutMirror.str();

    cout.rdbuf(origStdout);
    cin.rdbuf(origStdin);

    fin.open(filename.str().c_str());

    if(fin.is_open()){

        string line;
        getline(fin, line);
        while(!fin.fail()){
            actualFilecontentStream << line << endl;
            getline(fin, line);
        }
        actualFileContent = actualFilecontentStream.str();
        fin.close();

        remove(filename.str().c_str());

        if(expectedStdout == actualStdout && expectedFileContent == actualFileContent){
            cout << "Test " << testNum << " passed! Your output matches the "
                << "expected output. Console output:" <<endl
                << ">>>>>>" << endl
                << expectedStdout << endl
                << "<<<<<<" << endl << endl;
            cout << "File contents:" << endl
                << ">>>>>" << endl 
                << expectedFileContent << endl 
                << "<<<<<" << endl << endl;
            return true;
        } else {
            cout << "Test " << testNum << " failed. Expected console output:" << endl
                << ">>>>>>" << endl
                << expectedStdout << endl
                << "<<<<<<" << endl
                << "The actual console output:" << endl
                << ">>>>>>" << endl
                << actualStdout << endl
                << "<<<<<<" << endl << endl;
            cout << "Expected file contents: " << endl
                << ">>>>>>" << endl
                << expectedFileContent << endl
                << "<<<<<<" << endl
                << "The actual file contents:" << endl
                << ">>>>>>" << endl
                << actualFileContent << endl
                << "<<<<<<" << endl << endl;
            return false;
        }
    } else {
        cout << "Test " << testNum << " failed. The output file was not "
             << "produced." << endl << endl;
        return false;
    }
}

bool NonExistentDirectoryTest(int testNum){
    ostringstream tmp("");

    Contact contact;
    tmp << "Jane Doe " << testNum;
    contact.name = tmp.str();
    tmp.str("");
    tmp << "jdoe" << testNum << "@mail.com";
    contact.email = tmp.str();
    tmp.str("");
    for(int i = 0; i < 12; i++){
        if(i == 4 || i == 8){
            tmp << "-";
        } else {
            tmp << rand()%10;
        }
    }
    contact.phoneNumber= tmp.str();
    contact.birthYear = rand()%80 + 1960;
    contact.birthMonth = rand()%12 + 1;
    contact.birthDay = rand()%27+1;

    ostringstream filename("");
    filename << "test_" << testNum << "_" << rand()%1000 
             << "/test_" << testNum << "_" << rand()%1000;
    ostringstream inputStream("");
    inputStream << contact.name << endl
                << contact.email << endl
                << contact.phoneNumber << endl
                << contact.birthYear << endl
                << contact.birthMonth << endl
                << contact.birthDay << endl
                << filename.str() << endl;

    string expected, actual;
    ostringstream stdoutMirror, expectedStream("");
    istringstream stdInMirror(inputStream.str());
    streambuf *origStdout, *origStdin;
    origStdout = cout.rdbuf();
    cout.rdbuf(stdoutMirror.rdbuf());
    origStdin = cin.rdbuf();
    cin.rdbuf(stdInMirror.rdbuf());

    Run();

    expectedStream << "Name: Email: Phone number: Birth year: Birth month: " 
                   << "Birth day: Filename: Error: file couldn't be opened.\n";
    expected = expectedStream.str();
    actual = stdoutMirror.str();

    //remove(filename.c_str());
    cout.rdbuf(origStdout);
    cin.rdbuf(origStdin);


    if(expected == actual){
        cout << "Test " << testNum << " passed! Your output matches the "
             << "expected output." <<endl
             << ">>>>>>" << endl
             << expected << endl
             << "<<<<<<" << endl << endl;
        return true;
    } else {
        cout << "Test " << testNum << " failed. Expected output:" << endl
             << ">>>>>>" << endl
             << expected << endl
             << "<<<<<<" << endl
             << "The actual output:" << endl
             << ">>>>>>" << endl
             << actual << endl
             << "<<<<<<" << endl;
        return false;
    }
}
