// Guided Inquiry 26.3
//
// Instructions
// ------------
// The program below should:
//  1. Prompt the user for the name of a file
//  2. Write the 2D array `table` (a paramter of `Run()`) to the given
//     file such that every row of the table is on its own line and each
//     column is separated by a space; for simplicity, place a space after
//     each cell, including the last one on a line, and a newline after every
//     row, including the last row.
//
// Complete `Run()` so that it performs those operations.
//
// Testing
// -------
// To test your code, compile as usual, but when you run, do this:
//
//     ./gi26.3 -test
//
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <cstdlib>
#include <ctime>
using namespace std;

const int ROWS = 10;
const int COLS = 100;


// For testing; do not modify.
void PopulateTable(int table[ROWS][COLS]);
void RunTests();
bool RandomFileTest(int testNum);
bool NonExistentDirectoryTest(int testNum);
// End testing declarations.



struct Contact {
    string name, email, phoneNumber;
    int birthYear, birthMonth, birthDay;
};

void Run(int table[ROWS][COLS]){
    // TODO Your code goes here.

    // create output file stream instance; call it fout
    // declare a string to hold the filename
    // prompt the user for the name of the file to write to: "Filename: " (no 
    //      new line)
    // use getline to read in the filename
    // open file for writing
    // if it didn't open:
    //    print an error message: "Error: file couldn't be opened." with newline
    //          at the end
    //    return
    // write the table to the output file as detailed in the instructions
    // close the file -- this is hugely important when writing to a file (not
    //                   closing could cause some data to not be written to the
    //                   file)
}

int main(int argc, char **argv) {
    // For testing. Don't modify this code.
    srand(time(0));
    if(argc > 1 && string(argv[1]) == "-test"){
        RunTests();
    } else {
        int table[ROWS][COLS];
        PopulateTable(table);
        Run(table);
    }
    // End testing.

    return 0;
}





// ============================================================================
// IGNORE the testing function definitions below here. 
// ---------------------------------------------------
void RunTests(){
    const int TESTS = 5;
    int testsPassed = 0;

    cout << string(80, '=') << endl
         << "TESTS" << endl
         << string(40, '-') << endl;
    for(int i = 0; i < TESTS-1; i++){
        if(RandomFileTest(i+1))
            testsPassed++;
        cout << string(40, '-') << endl;
    }
    if(NonExistentDirectoryTest(TESTS))
        testsPassed++;
    cout << string(40, '-') << endl;

    cout << endl << "*** " << testsPassed << " of " << TESTS 
         << " tests passed. ***" << endl << endl;
}

bool RandomFileTest(int testNum){
    ostringstream tmp("");
    int table[ROWS][COLS];
    PopulateTable(table);
    

    ostringstream filename("");
    filename << "test_" << testNum << "_" << rand()%1000;
    ostringstream inputStream("");
    inputStream << filename.str() << endl;

    for(int i = 0; i < ROWS; i++){
        for(int j = 0; j < COLS; j++){
            tmp << table[i][j] << " ";
        }
        tmp << endl;
    }
    

    ifstream fin;
    string expectedStdout, actualStdout, expectedFileContent = tmp.str(), 
           actualFileContent;
    ostringstream stdoutMirror, expectedStream(""), actualFilecontentStream("");
    istringstream stdInMirror(inputStream.str());
    streambuf *origStdout, *origStdin;
    


    origStdout = cout.rdbuf();
    cout.rdbuf(stdoutMirror.rdbuf());
    origStdin = cin.rdbuf();
    cin.rdbuf(stdInMirror.rdbuf());

    Run(table);

    expectedStdout = "Filename: ";
    actualStdout = stdoutMirror.str();

    cout.rdbuf(origStdout);
    cin.rdbuf(origStdin);

    fin.open(filename.str().c_str());

    if(fin.is_open()){

        string line;
        getline(fin, line);
        while(!fin.fail()){
            actualFilecontentStream << line << endl;
            getline(fin, line);
        }
        actualFileContent = actualFilecontentStream.str();
        fin.close();

        remove(filename.str().c_str());

        if(expectedStdout == actualStdout && expectedFileContent == actualFileContent){
            cout << "Test " << testNum << " passed! Your output matches the "
                << "expected output. Console output:" <<endl
                << ">>>>>>" << endl
                << expectedStdout << endl
                << "<<<<<<" << endl << endl;
            cout << "File contents:" << endl
                << ">>>>>" << endl 
                << expectedFileContent << endl 
                << "<<<<<" << endl << endl;
            return true;
        } else {
            cout << "Test " << testNum << " failed. Expected console output:" << endl
                << ">>>>>>" << endl
                << expectedStdout << endl
                << "<<<<<<" << endl
                << "The actual console output:" << endl
                << ">>>>>>" << endl
                << actualStdout << endl
                << "<<<<<<" << endl << endl;
            cout << "Expected file contents: " << endl
                << ">>>>>>" << endl
                << expectedFileContent << endl
                << "<<<<<<" << endl
                << "The actual file contents:" << endl
                << ">>>>>>" << endl
                << actualFileContent << endl
                << "<<<<<<" << endl << endl;
            return false;
        }
    } else {
        cout << "Test " << testNum << " failed. The output file was not "
             << "produced." << endl << endl;
        return false;
    }
}

bool NonExistentDirectoryTest(int testNum){
    ostringstream tmp("");

    int table[ROWS][COLS];
    PopulateTable(table);

    ostringstream filename("");
    filename << "test_" << testNum << "_" << rand()%1000 
             << "/test_" << testNum << "_" << rand()%1000;
    ostringstream inputStream("");
    inputStream << filename.str() << endl;

    string expected, actual;
    ostringstream stdoutMirror, expectedStream("");
    istringstream stdInMirror(inputStream.str());
    streambuf *origStdout, *origStdin;
    origStdout = cout.rdbuf();
    cout.rdbuf(stdoutMirror.rdbuf());
    origStdin = cin.rdbuf();
    cin.rdbuf(stdInMirror.rdbuf());

    Run(table);

    expectedStream << "Filename: Error: file couldn't be opened.\n";
    expected = expectedStream.str();
    actual = stdoutMirror.str();

    //remove(filename.c_str());
    cout.rdbuf(origStdout);
    cin.rdbuf(origStdin);


    if(expected == actual){
        cout << "Test " << testNum << " passed! Your output matches the "
             << "expected output." <<endl
             << ">>>>>>" << endl
             << expected << endl
             << "<<<<<<" << endl << endl;
        return true;
    } else {
        cout << "Test " << testNum << " failed. Expected output:" << endl
             << ">>>>>>" << endl
             << expected << endl
             << "<<<<<<" << endl
             << "The actual output:" << endl
             << ">>>>>>" << endl
             << actual << endl
             << "<<<<<<" << endl;
        return false;
    }
}

void PopulateTable(int table[ROWS][COLS]){
    for(int i = 0; i < ROWS; i++){
        for(int j = 0; j < COLS; j++){
            table[i][j] = rand()%10000-5000;
        }
    }
}